(function(w) {
	// 空函数
	function shield() {
		return false;
	}
	document.addEventListener('touchstart', shield, false); //取消浏览器的所有事件，使得active的样式在手机上正常生效
	document.oncontextmenu = shield; //屏蔽选择函数

	// H5 plus事件处理
	var ws = null,
		as = 'pop-in';
	var wgtVer = null;

	function plusReady() {
		ws = plus.webview.currentWebview();
		plus.navigator.setStatusBarBackground("transparent"); //设置系统状态栏背景色
		plus.navigator.setStatusBarStyle('light'); //设置系统状态栏字体颜色
		// Android处理返回键
		plus.key.addEventListener('backbutton', function() {
			back();
		}, false);

	}
	if(w.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
	// DOMContentLoaded事件处理
	var domready = false;
	document.addEventListener('DOMContentLoaded', function() {
		domready = true;
		gInit();
		document.body.onselectstart = shield;
	}, false);
	// 处理返回事件
	w.back = function(hide) {
		if(w.plus) {
			ws || (ws = plus.webview.currentWebview());
			try{
				ws.opener().evalJS('ssss()');
			}catch(e){
				//TODO handle the exception
			}
			if(hide || ws.preate) {
				ws.hide('auto');
			} else {
				ws.close('auto');
			}
		} else if(history.length > 1) {
			history.back();
		} else {
			w.close();
		}
	};
	//检查更新
	w.checkUpdate = function(ckurl, upurl) {
		if(w.plus) {
			plus.nativeUI.showWaiting("检测更新...");
			var xhr = new XMLHttpRequest();
			xhr.onreadystatechange = function() {
				switch(xhr.readyState) {
					case 4:
						plus.nativeUI.closeWaiting();
						if(xhr.status == 200) {
							// 获取本地应用资源版本号
							plus.runtime.getProperty(plus.runtime.appid, function(inf) {
								localStorage.setItem('wgtVer', inf.version);
								console.log("当前应用版本：" + inf.version);
							});
							console.log("检测更新成功：" + xhr.responseText);
							var newVer = xhr.responseText;
							var wgtVer = localStorage.getItem('wgtVer');
							if(wgtVer && newVer && (wgtVer != newVer)) {
								update(upurl); // 下载升级包
							} else {
								plus.nativeUI.alert("无新版本可更新！");
							}
						} else {
							console.log("检测更新失败！");
							plus.nativeUI.alert("检测更新失败！");
						}
						break;
					default:
						break;
				}
			}
			xhr.open('GET', ckurl);
			xhr.send();
		}
	}
	//差量更新	
	w.update = function(url) {
		if(w.plus) {
			var wgtWaiting = plus.nativeUI.showWaiting("升级中...");
			var dtask = plus.downloader.createDownload(url, {
				method: "GET"
			}, function(d, status) {
				console.log(plus.runtime.version)
				if(status == 200) {
					console.log("下载成功: " + d.filename)
					plus.runtime.install(d.filename, {}, function() {
						wgtWaiting.setTitle("开始安装");
						plus.nativeUI.alert("更新成功！", function() {
							plus.runtime.restart();
						});
					}, function(e) {
						wgtWaiting.close();
						plus.nativeUI.alert("Update wgtu failed: " + e.message);
					});
				} else {
					plus.nativeUI.closeWaiting();
					alert("Download wgtu failed: " + status);
				}
			});
			dtask.addEventListener('statechanged', function(d, status) {
				switch(d.state) {
					case 2:
						wgtWaiting.setTitle("已连接到服务器");
						break;
					case 3:
						var percent = d.downloadedSize / d.totalSize * 100;
						wgtWaiting.setTitle("已下载 " + parseInt(percent) + "%");
						break;
					case 4:
						wgtWaiting.setTitle("下载完成");
						break;
				}
			});
			dtask.start();
		}
	}
	// 处理点击事件
	var openw = null,
		waiting = null;
	/**
	 * 打开新窗口
	 * @param {URIString} id : 要打开页面url
	 * @param {boolean} wa : 是否显示等待框
	 * @param {boolean} ns : 是否不自动显示
	 * @param {JSON} ws : Webview窗口属性
	 */
	w.clicked = function(id, wa, ns, ws) {
		if(openw) { //避免多次打开同一个页面
			return null;
		}		
		if(w.plus) {
			//判断登录状态
			
			if(getItem("islogin")!="1"){				
				if(id.indexOf("www/index.html")!=-1 ||id.indexOf("trip/index.html")!=-1 || id.indexOf("trip/trip_about.html")!=-1|| id.indexOf("login")!=-1){					
				}else{
					id="_www/www/login/login.html"
				}
			}
			//排行榜询问
			if(id.indexOf("task/")!=-1){
				if(getItem("istask")==null){
					plus.nativeUI.confirm("完成任务的数据会生成排行榜\n 是否显示我的数据",function(e){
						 global_ajax("&mo=u&a=is_show_myability",{"openability":e.index},function(data){
						 	console.log(JSON.stringify(data))
						 });						
						setItem("istask",e.index)
					} ,  {"title":"提示",
						"buttons":["不显示","显示"]
					})
				}
			}
			
			wa && (waiting = plus.nativeUI.showWaiting());
			ws = ws || {};
			ws.scrollIndicator || (ws.scrollIndicator = 'none');
			ws.scalable || (ws.scalable = false);
			var pre = ''; //'http://192.168.1.178:8080/h5/';
			openw = plus.webview.create(pre + id, id, ws, {
				popGesture: 'hide'
			});
			var sws=plus.nativeUI.showWaiting();
			ns || openw.addEventListener('loaded', function() { //页面加载完成后才显示
				//		setTimeout(function(){//延后显示可避免低端机上动画时白屏
				openw.show(as);
				sws.close();
//				if(plus.os.name=="iOS"){
//					openw.setStyle({
//						softinputMode: "adjustResize"
//					});
//				}
				//closeWaiting();
				//		},200);
			}, false);
			openw.addEventListener('close', function() { //页面关闭后可再次打开
				openw = null;
			}, false);
			return openw;
		} else {
			w.location.href=id;
		}
		return null;
	};
	w.openDoc = function(t, c) {
		var d = plus.webview.getWebviewById('document');
		if(d) {
			d.evalJS('updateDoc("' + t + '","' + c + '")');
		} else {
			d = plus.webview.create('/plus/doc.html', 'document', {
				zindex: 9999,
				popGesture: 'hide'
			}, {
				preate: true
			});
			d.addEventListener('loaded', function() {
				d.evalJS('updateDoc("' + t + '","' + c + '")');
			}, false);
		}
	}
	/**
	 * 关闭等待框
	 */
	w.closeWaiting = function() {
		waiting && waiting.close();
		waiting = null;
	}
	w.compatibleConfirm = function() {
		plus.nativeUI.confirm('本OS原生层面不提供该控件，需使用mui框架实现类似效果。请点击“确定”下载Hello mui示例', function(e) {
			if(0 == e.index) {
				//plus.runtime.openURL("http://www.dcloud.io/hellomui/");
			}
		}, "", ["确定", "取消"]);
	}
	// 通用元素对象
	var _dout_ = null,
		_dcontent_ = null;
	w.gInit = function() {
		_dout_ = document.getElementById("output");
		_dcontent_ = document.getElementById("dcontent");
	};
	// 清空输出内容
	w.outClean = function() {
		_dout_.innerText = "";
		_dout_.scrollTop = 0; //在iOS8存在不滚动的现象
	};
	// 输出内容
	w.outSet = function(s) {
		_dout_.innerText = s + "\n";
		(0 == _dout_.scrollTop) && (_dout_.scrollTop = 1); //在iOS8存在不滚动的现象
	};
	// 输出行内容
	w.outLine = function(s) {
		_dout_.innerText += s + "\n";
		(0 == _dout_.scrollTop) && (_dout_.scrollTop = 1); //在iOS8存在不滚动的现象
	};
	// 格式化时长字符串，格式为"HH:MM:SS"
	w.timeToStr = function(ts) {
		if(isNaN(ts)) {
			return "--:--:--";
		}
		var h = parseInt(ts / 3600);
		var m = parseInt((ts % 3600) / 60);
		var s = parseInt(ts % 60);
		return(ultZeroize(h) + ":" + ultZeroize(m) + ":" + ultZeroize(s));
	};
	// 格式化日期时间字符串，格式为"YYYY-MM-DD HH:MM:SS"
	w.dateToStr = function(d) {
		return(d.getFullYear() + "-" + ultZeroize(d.getMonth() + 1) + "-" + ultZeroize(d.getDate()) + " " + ultZeroize(d.getHours()) + ":" + ultZeroize(d.getMinutes()) + ":" + ultZeroize(d.getSeconds()));
	};
	// 格式化日期字符串
	w.dateToStr1 = function(d) {
		return(d.getFullYear() + "-" + ultZeroize(d.getMonth() + 1) + "-" + ultZeroize(d.getDate()));
	};
	/**
	 * zeroize value with length(default is 2).
	 * @param {Object} v
	 * @param {Number} l
	 * @return {String} 
	 */
	w.ultZeroize = function(v, l) {
		var z = "";
		l = l || 2;
		v = String(v);
		for(var i = 0; i < l - v.length; i++) {
			z += "0";
		}
		return z + v;
	};

	//上传图片
	w.uploadImg = function(ajaxUrl, src, inp_el, func) {
//		console.log(func)
		var func = func;
//		return false
		var task = plus.uploader.createUpload(ajaxUrl, {
			method: 'post',
			blocksize: 204800,
			timeout: 20000
		}, function(upload, status) {
			if(upload.state == 4 && status == 200) {
				//console.log(JSON.stringify(upload.responseText)); //服务器返回存在这里
				var data = eval("(" + upload.responseText + ")")
				//	    	alert(data.status);
				if(data.status == "1") {			
					uploadImgS(data, inp_el, func); //设置表单val值
				}
				plus.uploader.clear(); //清除上传
			}
		});
		for(var i in src) {
			task.addFile(src[i], {
				key: 'file' + i
			});
			//console.log(src[i],222, 'file' + i)
		}
		task.addData('type', 'uploadImg');
		if(getItem("encode") && getItem("encode") != "null") {
			task.setRequestHeader("MEMBER-ENCODE", getItem("encode"));
		}
		//	  task.addData('userId', );
		//	  task.addEventListener('statechanged', stateChanged, false);
		// console.log(2)
		task.start();

		//	  function stateChanged(upload, status) {
		//	    if ( upload.state == 4 && status == 200 ) {
		//	     
		//	      console.log(JSON.stringify(upload));  //服务器返回存在这里
		//	      plus.uploader.clear();  //清除上传
		//	    }
		//	  }
	}
	//再对图片进行压缩为270*270，再上传到服务器
	w.resizeImage = function(ajaxUrl, src, inp_el, func) {
		var func = func;
		var files = [];
		if(src.indexOf(",")!=-1) var src = [src];  //判断多图还是单图
		var compressImage = function(num) {
			
			var path = src[num];
			var date = new Date();
			var num1 = Math.round(Math.random()*100+1);
			num1 = date.getTime() + String(num1);
			plus.zip.compressImage({
					src: path,
					dst: '_doc/'+ num1 +'.jpg',
					overwrite: true,
					width: '160px',
					format: 'jpg',
					quality: 75 //图片质量不再修改，以免失真
				},
				function(e) {
					plus.nativeUI.closeWaiting();
					files.push(e.target);
					if(num == src.length - 1) {
						uploadImg(ajaxUrl, files, inp_el, func); //上传图片, e.target存的是本地路径！
					} else {
						compressImage(num + 1);
					}
				},
				function(err) {
					plus.nativeUI.alert('未知错误！', function() {
						mui.back();
					});
				}
			);
		}
		compressImage(0);
	}
	// 从相册中选择单张图片
	w.galleryImg = function(call) {
		// 从相册中选择图片
		console.log("从相册中选择图片:");
		plus.gallery.pick(function(path) {
			call(path);
		}, function(e) {
			console.log("取消选择图片");
		}, {
			filter: "image"
		});
	}

	// 从相册中选择多张图片 
	var lfs = null; // 保留上次选择图片列表 
	w.galleryImgs = function(call,num) {
		// 从相册中选择图片
		var sn=num?num:9;
		console.log("从相册中选择多张图片:");
		plus.gallery.pick(function(e) {
			var files = [];
			lfs=e.files;
			call(e.files);
		}, function(e) {
			console.log("取消选择图片");
		}, {
			filter: "image",
			multiple: true,
			selected: lfs,
			maximum: sn,
			system: false,
			onmaxed: function() {
				plus.nativeUI.alert('最多只能选择9张图片');
			}
		}); // 最多选择9张图片 
	}
	//压缩图片
	//再对图片进行压缩为270*270，再上传到服务器
	w.resizeImage_2 = function(src, option,call) {
		var func = func;
		var files = [];
			if(typeof src == "string") src=[src];
			//if()
		var compressImage = function(num) {
			var path = src[num];
			var date = new Date();
			var num1 = Math.round(Math.random()*100+1);
			num1 = date.getTime() + String(num1);
			var option1={
					src: path,
					dst: '_doc/'+ num1 +'.jpg',
					overwrite: true,
					width: '300px',
					format: 'jpg',
					quality: 75 //图片质量不再修改，以免失真
				}
			for (var i in option ) {//改变属性
				option1[i] = option[i];
			}
			
			plus.zip.compressImage(option1,
				function(e) {
					plus.nativeUI.closeWaiting();
					files.push(e.target);					
					if(num == src.length - 1) {
						call(files); //全部压缩完成回调
					} else {
						compressImage(num + 1);
					}
				},
				function(err) {
					plus.nativeUI.alert('未知错误！', function() {
						//back();
					});
				}
			);
		}
		compressImage(0);
	}
	
	//上传图片2
	w.uploadImg_2 = function(ajaxUrl, src,call) {
		var call=call;
		var updata=plus.nativeUI.showWaiting("正在上传请等待...");
		var task = plus.uploader.createUpload(ajaxUrl, {
			method: 'post',
			blocksize: 204800,
			timeout: 20000
		}, function(upload, status) {
			if(upload.state == 4 && status == 200) {
				var data = eval("(" + upload.responseText + ")")
				//	    	alert(data.status);
				if(data.status == "1") {	
					call(data);
				}else{
					alert("上传失败,请重新上传")
				}
				updata.close();
				plus.uploader.clear(); //清除上传
			}
		});
		for(var i in src) {
			task.addFile(src[i], {
				key: 'file' + i
			});
		}
		task.addData('type', 'uploadImg');
		if(getItem("encode") && getItem("encode") != "null") {
			task.setRequestHeader("MEMBER-ENCODE", getItem("encode"));
		}
		task.start();
	}
	
	
	//获取应用存储的值
	w.getItem = function(key) {
		if(navigator.userAgent.match(/Html5Plus/i)) {			
			return plus.storage.getItem(key);
		} else {
			return localStorage.getItem(key)
		}
	}
	//修改或添加键值(key-value)对数据到应用数据存储中
	w.setItem = function(key, value) {
		console.log(typeof value);
		if(typeof value =="number") var value=value.toString();
		if(navigator.userAgent.match(/Html5Plus/i)) {
			return plus.storage.setItem(key, value);
		} else {
			return localStorage.setItem(key, value);
		}
	}
	//通过key值删除键值对存储的数据
	w.removeItem = function(key) {
		if(navigator.userAgent.match(/Html5Plus/i)) {
			plus.storage.removeItem(key);
		} else {
			localStorage.removeItem(key);
		}
	}
	//清除应用所有的键值对存储数据
	w.clearItem = function() {
		if(navigator.userAgent.match(/Html5Plus/i)) {
			plus.storage.clear();
		} else {
			localStorage.clear();
		}
	}

	//退出登录 
	w.checkLogin = function() {
		var islogin = getItem("islogin");
		if(islogin == "1") {
			clearItem();
			$_toast("退出登录！");
			setTimeout(function(){plus.runtime.restart();},300)//重启APP
		}
		//清除微信登陆信息
		plus.oauth.getServices(function (services) {
            for (var i in services) {
                var service = services[i];
                service.logout();
            }
        });
	}
	
	//选择日期 
	w.pickDate = function(call) {
		plus.nativeUI.pickDate(function(e) {
			call(e.date);
		}, function(e) {
			console.log( "未选择日期："+e.message );
		}, {title: "请选择日期:"});
	}
	// 选择时间
    w.pickTime = function(call){
    		var t = new Date();
		plus.nativeUI.pickTime( function(e){
			var d=e.date;
			call(d);
			console.log( "选择的时间："+d.getHours()+":"+d.getMinutes() );
		},function(e){
			console.log( "未选择时间："+e.message );
		}, {title: "请选择集合时间：" ,time: t});
	}
	
	//系统提示框
	//	w.alert = function(cont,tit,btntxt) {
	//		plus.nativeUI.alert( cont, function(){
	//
	//		}, tit, btntxt );
	//	}
	
})(window);