
var server = root+"/app_ver_update.php"; //获取升级描述文件服务器地址
var wgtver;
var keyUpdate="updateCheck";//取消升级键名
var checkInterval=1*60*1000;//升级检查间隔，单位为ms,7天为7*24*60*60*1000=604800000, 如果每次启动需要检查设置值为0
var wsn=null;
function getAppInfo() {
	
	// 判断升级检测是否过期
	
	// 判断升级检测是否过期
	
	plus.runtime.getProperty(plus.runtime.appid, function(wgtinfo) {
		wgtver = wgtinfo.version;		
		update();		
	});
}
/**
 * 比较版本大小，如果新版本nv大于旧版本ov则返回true，否则返回false
 * @param {String} ov
 * @param {String} nv
 * @returN {Boolean}
 */
function compareVersion(ov, nv) {
	if(!ov || !nv || ov == "" || nv == "") {
		return false;
	}
	var b = false,
		ova = ov.split(".", 4),
		nva = nv.split(".", 4);
	for(var i = 0; i < ova.length && i < nva.length; i++) {
		var so = ova[i],
			no = parseInt(so),
			sn = nva[i],
			nn = parseInt(sn);
		if(nn > no || sn.length > so.length) {
			return true;
		} else if(nn < no) {
			return false;
		}
	}
	if(nva.length > ova.length && 0 == nv.indexOf(ov)) {
		return true;
	}
}

function update() {
	if(mui.os.android) {
		var system = "android";
	} else if(mui.os.ios) {
		var system = "ios";
	}
	mui.getJSON(server, {
		"appid": plus.runtime.appid,
		"version_app": plus.runtime.version,
		"version_zy": wgtver,
		"imei": plus.device.imei,
		"system": system
	}, function(data) {
		console.log(JSON.stringify(data));
		var info = data.result;
		if(info.type<=3 && info.url) {
			
			//wsn=plus.nativeUI.closeWaiting();
			// 弹出提示信息对话框
//			plus.nativeUI.alert( "系统版本升级", function(e){
//				console.log("Close confirm: "+e.index);
//				wsn=plus.nativeUI.showWaiting("系统升级中...");
//				downWgt(info.url);
//			});

			wsn=plus.nativeUI.showWaiting("应用资源更新中,请等待...");
			downWgt(info.url);
			
		}else if(info.type==4){
			plus.runtime.openURL(info.url);
		}
	});
}
// 下载更新包
function downWgt(path) {
	console.log("下载更新包")
	plus.downloader.createDownload(path, {
		filename: "_doc/update/"
	}, function(d, status) {
		console.log(status)
		if(status == 200) {
			installWgt(d.filename); // 安装wgt包
		}
	}).start();
}
// 更新应用资源
function installWgt(path) {
	//force参数强制安装
	plus.runtime.install(path, {
		force: true
	}, function() {
		wsn.close()
		plus.nativeUI.alert("应用资源更新完成，需要重启APP！", function() {
			plus.runtime.restart();
		});
	}, function(e) {
		wsn.close()
		plus.nativeUI.alert("安装更新文件失败[" + e.code + "]：" + e.message);
	});
}
mui.os.plus && !mui.os.stream && mui.plusReady(getAppInfo);